local particle={}
particle.__index=particle
function particle.new(x,y,vx,vy,lifespan,color)
	local p = setmetatable({},particle)
	p.vx = vx or 0 -- set p.vx to vx, if it's nil then set it to default value (0)
	p.vy = vy or 0
	p.x  = x  or 0
	p.y  = y  or 0
	
	p.ls = lifespan or 10
	p.timer=p.ls
	p.alive=true
	p.color = color or {255,255,255}
	return p
end

function particle:draw()
	if self.alive then
		love.graphics.setColor(self.color[1]+20,self.color[2]+20,self.color[3]+20)
		love.graphics.setPointSize(5)
		love.graphics.points(self.x,self.y)
	end
end

function particle:update(dt)
	if self.alive then
		self.x=self.x+self.vx*dt
		self.y=self.y+self.vy*dt
		self.timer=self.timer-1*dt
		if self.timer<=0 then
			self.alive=false
		end
	end
end

return particle