
local curse = require 'lib/curse'
local colors = require 'lib/MaterialDesign/colors'
local hexes=require'lib/hexDataTable'
local particle=require'lib/Particle'
--local Menu=require'lib/Menu'.new()
local timer=require 'lib/timer'
local AStar=require 'lib/AStar'
--[[
	TEST BUILD.
	TODO:
		Second type of movement(COMPLETED):
			Can swap two controlled hexagons
			Will be controlled via right mouse button (will highlight all the clicked hexagons neighbors and the player will click on the one they want to swap with) 
	TODO: 
		Allow AI to take advantage of swapping mechanic.
		Possible solutions:
			A* pathfinding to find the shortest route. Use data to determine which hexagons to swap with to get to the target.(DONE)
		
]]

local swapping=false
local swappingWith
local playing = false
local aliveParticles={}
local robotoFont12 = love.graphics.newFont("Assets/Roboto-Bold.ttf",12)
local robotoFont24 = love.graphics.newFont("Assets/Roboto-Bold.ttf",24)
local robotoFont32 = love.graphics.newFont("Assets/Roboto-Bold.ttf",32)
local AIAmount=0 -- store amount of AI controlled hexagons
local PlayerAmount=0 -- store amount of player controlled hexagons 
local turn="1"
local AITimer=timer.new()
local AIChoosing=false
local PlayerLost=false
local clickDelay=0.1
local clickDelayTimer=clickDelay
local AILost=false
local hovering
local beginNode
local endNode
local choosing="1" -- 1 = choosing beginNode, 2 = choosing endNode, 0 = already chosen both end and begin node
--[[
	Currently testing:
		Pathfinding
]]

function love.load()
	hexes.hexagonData=setmetatable({},hexes)
	love.window.setMode(600,600,{msaa="12"})
	hexGrid = curse.createHexagonalGrid(7, 30, 120, 180,0)
	local ind = 0
	for hexa in hexGrid:hexIterator() do
		ind=ind+1
		local txt=ind%love.math.random(1,5)==0 and "1" or "2"
		table.insert(hexes.hexagonData,{["hex"]=hexa,["type"]=hexes.randomType(),["fill"]="fill",["hovering"]=false,["selected"]=false,["text"]=txt,["outline"]=false,f=0,g=0,h=0,previous=nil} )
		-- if txt=="1" then
			-- PlayerAmount=PlayerAmount+1
		-- elseif txt=="2" then
			-- AIAmount=AIAmount+1		
		-- end
	end
	local ind = 0
end


-- local function CanPlayerMove()
	-- -- checking if the player and ai can move
	-- --print("Checking if player can move!")
	-- local playerHexagons={}
	-- local playerHexagonsThatCanMove={}
	
	-- for _, hexes in pairs(hexes.hexagonData) do
		-- if hexes["text"]=="1" then
			-- table.insert(playerHexagons,hexes)
		-- end
	-- end
	-- for _, pHexagon in pairs(playerHexagons) do
		-- local h = pHexagon["hex"]
		-- local n = hexGrid:neighbors(h.q,h.r)
		-- for _, neighbor in pairs(n) do
			-- if neighbor ~= nil then
				-- local n2=hexes.getHexagon(neighbor)
				-- local nE=n2["type"]["name"]
				-- local hE=pHexagon["type"]["name"]
				-- if n2["text"]=="2" then
					-- if nE == "water" and hE=="earth" or nE=="fire" and hE == "water" or nE=="earth" and hE=="fire" then
						-- table.insert(playerHexagonsThatCanMove, pHexagon)
					-- end
				-- end
			-- end
		-- end
	-- end
	-- if #playerHexagonsThatCanMove == 0 then
		-- if PlayerAmount < AIAmount then
			-- --print("Player cannot move!")
			-- PlayerLost=true
		-- end
	-- end
	-- --print("Player can move!")
-- end

-- function AIChoose()
	-- if AIAmount > 0 then
		-- local function AIClick(hexagon)
			-- AITimer:script(function(wait)
				-- print("Clicking hexagon at q:",hexagon.q,"r:",hexagon.r)
				-- outlineEnemyNeighbors(hexagon,true,"1")
				-- wait(2)
				-- takeOverNeighbors(hexagon,"1")
				-- outlineEnemyNeighbors(hexagon,false,"1")
				-- turn="1"
				-- CanPlayerMove()			
			-- end)
		-- end
		-- local aiControlledHexes={}
		-- for _, hex in pairs(hexes.hexagonData) do
			-- if hex["text"]=="2" then
				-- local neighborCount=0
				-- local neighbors=hexGrid:neighbors(hex["hex"].q,hex["hex"].r)
				-- for dir, neighbor in pairs(neighbors) do
					-- if neighbor ~=nil and hexes.getHexagon(hexGrid:getHex(neighbor.q,neighbor.r))["fill"]=="fill" then 
						-- local neighborHexagon=hexGrid:getHex(neighbor.q,neighbor.r) 
						-- local neighborData=hexes.getHexagon(neighborHexagon) 
						-- if neighborData["text"]=="1" then
							-- if neighborData["type"]["name"]=="fire" and  hex["type"]["name"] == "water"
							-- or neighborData["type"]["name"]=="water" and hex["type"]["name"] == "earth" 
							-- or neighborData["type"]["name"]=="earth" and hex["type"]["name"] == "fire" then
								-- neighborCount=neighborCount+1
							-- end
						-- end
					-- end
				-- end
				-- table.insert(aiControlledHexes,{hex,neighborCount})
			-- end
		-- end
		-- local function rand()
			-- local difficulty=Menu.Settings["difficulty"]
			-- local chance=math.random(1,difficulty)
			-- --print("Chance:",chance)
			-- if chance<difficulty/10 and chance > 1 then
			-- --	print("AI is choosing the hexagon with the most amount of capturable neighbors!")
				-- return AIClick(aiControlledHexes[1][1]["hex"]) -- choose hexagon that can take over the most neighbors
			-- end
			-- if chance >= difficulty/10 and chance < difficulty then
				-- local randNum=math.random(1,#aiControlledHexes)
				-- if aiControlledHexes[randNum][2]>0 then
				-- --	print("AI is choosing a random hexagon!")				
					-- return AIClick(aiControlledHexes[randNum][1]["hex"]) -- choose a completely random hexagon
				-- end
			-- end
			-- if chance == 1 or chance == difficulty then
				-- if aiControlledHexes[#aiControlledHexes][2]>0 then
				-- --	print("AI is choosing the hexagon with the most amount of capturable neighbors!")				
					-- return AIClick(aiControlledHexes[#aiControlledHexes][1]["hex"]) -- choose hexagon that has the least amount of neighbors it can take over
				-- end
			-- end
			-- --print("AI has chosen a hexagon that cannot move. Choosing again!")
			-- return rand()
		-- end		
		-- table.sort(aiControlledHexes,function(a,b) return a[2] > b[2] end) -- sort table so the hexagon with the highest captureable neighbor count is the first index
		-- rand()
	-- end
-- end

function getSwapPath(swappingWith)
end



function love.update(dt)
	-- local mx,my=love.mouse.getPosition()
	-- if not playing then 
		-- Menu:update(dt)
	-- end
	-- if not playing and not Menu.Active then
		-- playing=true
	-- end
	-- if clickDelayTimer<clickDelay then
		-- clickDelayTimer=clickDelayTimer-1*dt
	-- end
	-- if clickDelayTimer<=0 then
		-- clickDelayTimer=clickDelay
	-- end	
	-- if playing then
		-- hovering=hexGrid:containingHex(mx,my)	
		-- AITimer:update(dt)
		-- for index, particle in pairs(aliveParticles) do
			-- particle:update(dt)
			-- if particle.alive==false then
				-- table.remove(aliveParticles,index)
			-- end
		-- end
		-- if hovering and not swapping and turn == "1" then -- if hovering isn't nil
			-- local hexagonData=hexes.getHexagon(hovering)
			-- for _, hexagon in pairs(hexes.hexagonData) do 
				-- if hexagon["hovering"] and hexagonData~=hexagon then
					-- hexagon["hovering"]=false
					-- local h = hexagon["hex"]
					-- outlineEnemyNeighbors(h,false,"2")
				-- end
			-- end
			-- if hexagonData["text"]=="1" then			
				-- hexagonData["hovering"]=true -- set the hexagon we're hovering over's hovering property to true. We'll keep track of this so we can stop outlining it's neighbors when it stops being hovered over.
				-- outlineEnemyNeighbors(hovering,true,"2")
			-- end
		-- elseif hovering==nil or swapping then
			-- for _, hexagon in pairs(hexes.hexagonData) do -- ugly fix for a bug where it wouldn't set previous hovered over hexagon's hovering property to false if you weren't hovering over anything
				-- if hexagon["hovering"] and hexagonData~=hexagon then
					-- hexagon["hovering"]=false
					-- local h = hexagon["hex"]
					-- outlineEnemyNeighbors(h,false,"2")
				-- end
			-- end
		-- end
	-- end
end

-- function outlineEnemyNeighbors(hexagon,bool,enemy)
	-- local neighbors=hexGrid:neighbors(hexagon.q,hexagon.r)
	-- if enemy=="1" and bool==true then
		-- print("Outlining hexagon at q:",hexagon.q,"r:",hexagon.r)
	-- elseif enemy=="1" and bool==false then
		-- print("un-outlining hexagon at q:",hexagon.q,"r:",hexagon.r)		
	-- end
	-- local hoveringData=hexes.getHexagon(hexagon)
	-- for _, neighbor in pairs(neighbors) do
		-- if neighbor ~= nil then
			-- local neighborData=hexes.getHexagon(neighbor)
			-- if neighborData["text"]==enemy and bool then
				-- if neighborData["type"]["name"]=="water" and hoveringData["type"]["name"]=="earth" 
				-- or neighborData["type"]["name"]=="fire"  and hoveringData["type"]["name"]=="water" 
				-- or neighborData["type"]["name"]=="earth" and hoveringData["type"]["name"]=="fire" then
					-- neighborData["outline"]=bool
				-- end
			-- elseif not bool and neighborData["text"]==enemy then
				-- neighborData["outline"]=bool
			-- end
		-- end
	-- end
-- end

-- function outlineFriendlyNeighbors(hexagon,bool,player)
	-- local neighbors=hexGrid:neighbors(hexagon.q,hexagon.r)
	-- for _, neighbor in pairs(neighbors) do
		-- if neighbor ~= nil then
			-- local neighborData=hexes.getHexagon(neighbor)
			-- if neighborData["text"]==player then
				-- neighborData["outline"]=bool
			-- end
		-- end
	-- end
-- end

-- function swapHexagons(h1,h2)
	-- local h1Data=hexes.getHexagon(h1)
	-- local h2Data=hexes.getHexagon(h2)
	-- local oldh2Type=h2Data["type"]["name"]
	-- local oldh2Color=h2Data["type"]["color"]
	-- h2Data["type"]["name"]=h1Data["type"]["name"]
	-- h2Data["type"]["color"]=h1Data["type"]["color"]
	-- h1Data["type"]["name"]=oldh2Type
	-- h1Data["type"]["color"]=oldh2Color
	-- h1Data["selected"]=false
	
	-- outlineFriendlyNeighbors(h1,false,"1")
	-- if h1Data["text"]=="1" then
		-- turn="2"
		-- AIChoose()
	-- else
		-- turn="1"
	-- end
-- end

-- function takeOverNeighbors(hexagon,enemy)
	-- print("taking over hexagons controlled by",enemy)
	-- local data=hexes.getHexagon(hexagon)
	-- local neighbors=hexGrid:neighbors(hexagon.q,hexagon.r)
	-- for _, neighbor in pairs(neighbors) do
		-- if neighbor~=nil then
			-- local nData=hexes.getHexagon(neighbor)
			-- local nType=nData["type"]["name"]
			-- local nColor=nData["type"]["color"]
			-- local dType=data["type"]["name"]
			-- local dColor=data["type"]["color"]
			-- local dText=data["text"]
			-- if nData["text"]==enemy then
				-- if nType=="water" and dType=="earth" 
				-- or nType=="earth" and dType=="fire"
				-- or nType=="fire"  and dType=="water" then
					-- for i = 1, 5 do
						-- local p = particle.new(neighbor.x,neighbor.y,math.random(-50,50),math.random(-50,50),2,nData["type"]["color"])
						-- table.insert(aliveParticles,p)
					-- end				
					-- nData["type"]["name"]=dType
					-- nData["type"]["color"]=dColor
					-- nData["text"]=dText
					-- nData["outline"]=false
					-- if enemy=="1" then
						-- AIAmount=AIAmount+1
						-- PlayerAmount=PlayerAmount-1
					-- else
						-- PlayerAmount=PlayerAmount+1
						-- AIAmount=AIAmount-1
					-- end
				-- end
			-- end
		-- end
	-- end
-- end

function love.mousepressed(x,y,button)
	if button==1 then
		print("Button 1 clicked!")
		if choosing=="1" then
			print("Choosing is 1")
			local hovering=hexGrid:containingHex(x,y) -- get hexagon at mouse position onclick			
			if hovering then
				beginNode=hovering
				local hoveringData=hexes.getHexagon(hovering)
				hoveringData["outline"]=true			
				choosing="2"
			end
		elseif choosing=="2" then
			local hovering=hexGrid:containingHex(x,y) -- get hexagon at mouse position onclick
			if hovering then
				endNode=hovering
				local hoveringData=hexes.getHexagon(hovering)
				hoveringData["outline"]=true
				local path=AStar.pathfind(beginNode,endNode,hexGrid)
				choosing="0"
				--print(path[2])							
			end
		end
	end
	
	-- if clickDelayTimer == clickDelay then
		-- clickDelayTimer=clickDelayTimer-.01
		-- if not playing and button==1 then
			-- Menu:click(x,y)
		-- end
		-- if turn=="1" then
			-- if button==1 then -- left mouse click
				-- if hovering and not swapping then
					-- local hData=hexes.getHexagon(hovering)
					-- if hData["text"]=="1" then
						-- takeOverNeighbors(hovering,"2")
						-- turn="2"
						-- AIChoose()											
					-- end
				-- elseif swapping and hovering then
					-- swapping=false
					-- swapHexagons(swappingWith,hovering)
					-- turn="2"
					-- AIChoose()				
				-- end
			-- end
			-- if button==2 and not swapping then -- right mouse click
				-- local hovering=hexGrid:containingHex(x,y)
				-- if hovering ~= nil then
					-- local hData=hexes.getHexagon(hovering)
					-- if hData["text"]=="1" then
						-- swapping=true
						-- hData["selected"]=true
						-- swappingWith=hData["hex"]
						-- outlineFriendlyNeighbors(hovering,true,"1")
					-- end
				-- end
			-- elseif button==2 and swapping then -- exit swapping mode
				-- if hovering ~= nil then
					-- local hData=hexes.getHexagon(hovering)
					-- if hData["selected"] then
						-- swapping=false
						-- swappingWith=nil
						-- hData["selected"]=false
						-- outlineFriendlyNeighbors(hovering,false,"1")						
					-- end
				-- end
			-- end
		-- end
	-- end
end




function love.draw()
	love.graphics.setColor(0,0,0)
	love.graphics.setFont(robotoFont12)
	-- love.graphics.print("Player controlled hexagons: "..tostring(PlayerAmount), 10, 10)
	-- love.graphics.print("AI controlled hexagons: "..tostring(AIAmount), 450, 10)
	love.graphics.setBackgroundColor(255,255,255)
	-- if not playing then
		-- Menu:draw()
	-- end
	--if playing then
		for hexagon in hexGrid:hexIterator() do
			local h=hexes.getHexagon(hexagon)
			local hCol=h["type"]["color"]
			drawHexagon(hexagon,h["fill"],not h["selected"] and hCol or {hCol[1]+20,hCol[2]+20,hCol[3]+20},h["outline"]) -- draw hexagons
		end
		-- if PlayerLost==true then
			-- love.graphics.setFont(robotoFont32)
			-- love.graphics.setColor(87,87,87)
			-- love.graphics.print("Player lost!",200,300,0,1,1)
		-- end
		-- if AILost==true then
			-- love.graphics.setFont(robotoFont32)
			-- love.graphics.setColor(87,87,87)			
			-- love.graphics.print("Player wins!",200,300,0,1,1)
		-- end
		-- for _, particle in pairs(aliveParticles) do
			-- particle:draw()
		-- end	
	--end
end

function drawHexagon(hex,mode,color,outline)
	love.graphics.setColor(color)
		love.graphics.polygon(
			mode ~= nil and mode or 'fill',
			hex.vertices[1].x, hex.vertices[1].y,
			hex.vertices[2].x, hex.vertices[2].y,
			hex.vertices[3].x, hex.vertices[3].y,
			hex.vertices[4].x, hex.vertices[4].y,
			hex.vertices[5].x, hex.vertices[5].y,
			hex.vertices[6].x, hex.vertices[6].y
		)
	if outline == true then
		love.graphics.setLineWidth(4)
		love.graphics.setColor(0,0,0,outline and 255 or 0)
		love.graphics.push()
		love.graphics.translate(hex.x*.06,hex.y*.06)
		love.graphics.scale(.94,.94)
		love.graphics.polygon(
			"line",
			hex.vertices[1].x, hex.vertices[1].y,
			hex.vertices[2].x, hex.vertices[2].y,
			hex.vertices[3].x, hex.vertices[3].y,
			hex.vertices[4].x, hex.vertices[4].y,
			hex.vertices[5].x, hex.vertices[5].y,
			hex.vertices[6].x, hex.vertices[6].y
		)
		love.graphics.pop()
	end
	love.graphics.setFont(robotoFont12)
	love.graphics.setColor(87,87,87)
	love.graphics.printf(hexes.getHexagon(hex)["text"],hex.x-(robotoFont12:getWidth(hexes.getHexagon(hex)["text"])/2),hex.y-(robotoFont12:getHeight()/2),32)

end
